; Calling API functions without using the invoke statement
; Author : Vortex

.386
.model flat,stdcall
option casemap:none

include     \GeneSys\include\windows.inc
include     Editbox.inc

includelib  \GeneSys\lib\user32.lib
includelib  \GeneSys\lib\kernel32.lib

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDC_EDIT    equ 1000
ID_TIMER    equ 2000

.data
DlgName     db "MyDialog",0
editboxtext	db "All the API functions are called without the invoke statement ",0
pChar       dd editboxtext

.data?
hInstance   HINSTANCE ?
CommandLine LPSTR ?
hCursor     dd ?

.code

start:

    GetModuleHandle,NULL
    mov hInstance,eax
    DialogBoxParam,hInstance,ADDR DlgName,NULL,ADDR DlgProc,NULL
    ExitProcess,eax

DlgProc PROC USES esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
    .IF uMsg==WM_INITDIALOG
            LoadCursor,0,IDC_CROSS
            mov hCursor,eax
            SetTimer,hWnd,ID_TIMER,150,0

    .ELSEIF uMsg==WM_CLOSE
            EndDialog,hWnd,NULL
	
    .ELSEIF uMsg==WM_SETCURSOR
            SetCursor,hCursor

    .ELSEIF uMsg==WM_TIMER
            mov esi,pChar
            movzx eax,BYTE PTR [esi]
            test eax,eax
            .IF ZERO?
                KillTimer,hWnd,ID_TIMER
            .ELSE
                push eax
                mov BYTE PTR [esi],0
                SetDlgItemText,hWnd,IDC_EDIT,ADDR editboxtext
                pop eax
                mov BYTE PTR [esi],al
                inc pChar
            .ENDIF
    .ELSE
            mov	eax,FALSE
            ret
    .ENDIF

    mov eax,TRUE
    ret

DlgProc ENDP
END start